
-- Fenetre permettant le flashage de l'cran

WinFlash= class(Turbine.UI.Window);

function WinFlash:Start()
	-- Positionne les fenetres
	local w,h = Turbine.UI.Display.GetSize();
	self:SetPosition(self.flashDim,self.flashDim);
	self:SetSize(w-self.flashDim*2,h-self.flashDim*2);
	self:SetVisible(true);
	self:SetBackColor(self.flashColor);
	self.top:SetPosition(0,0);
	self.top:SetSize(w,self.flashDim);
	self.top:SetBackColor(self.flashColor);
	self.bot:SetPosition(0,h-self.flashDim);
	self.bot:SetSize(w,self.flashDim);
	self.bot:SetBackColor(self.flashColor);
	self.left:SetPosition(0,self.flashDim);
	self.left:SetSize(self.flashDim,h-self.flashDim*2);
	self.left:SetBackColor(self.flashColor);
	self.right:SetPosition(w-self.flashDim,self.flashDim);
	self.right:SetSize(self.flashDim,h-self.flashDim*2);
	self.right:SetBackColor(self.flashColor);
	-- Positionne les compteurs
	self.startDth = math.floor(Turbine.Engine.GetGameTime()*self.flashTime);
	self.lastDth = 0; 
	self.endDth = wFlash.startDth + self.flashTime*1.5; 
	self:SetWantsUpdates(true);	
end
function WinFlash:Constructor()
	Turbine.UI.Window.Constructor(self);
	self:SetMouseVisible(false);
	self.top = Turbine.UI.Window();
	self.top:SetMouseVisible(false);
	self.bot = Turbine.UI.Window();
	self.bot:SetMouseVisible(false);
	self.left = Turbine.UI.Window();
	self.left:SetMouseVisible(false);
	self.right = Turbine.UI.Window();
	self.right:SetMouseVisible(false);
	self.flashDim = 20;
	self.flashTime = 20;
	self.flashColor = Turbine.UI.Color(1,0,0);
end
-- Positionne la couleur du flash (R,G,B entre 0 et 1)
function WinFlash:SetupColor(r,g,b)
	self.flashColor = Turbine.UI.Color(r,g,b)
end
-- Positionne la taille / dure du flash 
function WinFlash:Setup(odim,otime)
	self.dim = tonumber(odim) or 20;
	self.time = tonumber(otime) or 20;
end

function WinFlash:Update()
	local now = math.floor(Turbine.Engine.GetGameTime()*self.flashTime);
	if now > self.endDth then
		self:SetWantsUpdates(false);
		self:SetVisible(false);
		self.top:SetVisible(false);
		self.bot:SetVisible(false);
		self.left:SetVisible(false);
		self.right:SetVisible(false);
	elseif self.lastDth ~= now then
		self.lastDth = now;
		local v = self.lastDth-self.startDth;
		if v > self.flashTime and self:IsVisible() then
			self:SetVisible(false);
		else
			self:SetBackColor(Turbine.UI.Color(0.5*(self.flashTime-v)/self.flashTime,self.flashColor.r,self.flashColor.g,self.flashColor.b));
		end
		local c = (v % 3) == 0;
		self.top:SetVisible(c);
		self.bot:SetVisible(c);
		self.left:SetVisible(c);
		self.right:SetVisible(c);
	end
end

